Code

Fixed permission problem in addressbook plugin.
[gosa.git] / gosa-core / dh-make-gosa
index 203ca26f109d5c7947e9d4977091a0818bdfa53f..cdb53def3d5e835b6f6654c7264c099549fe2d6d 100755 (executable)
@@ -1,7 +1,25 @@
-#!/bin/bash
+#!/bin/sh
+# This code is part of GOsa (http://www.gosa-project.org)
+# Copyright (C) 2008 GONICUS GmbH
+#
+# ID: $$Id$$
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 usage() {
-  echo "Usage: ${0##*/} [--download] [-b|--branch branch] [-e|--email mail] [--depends] plugin-dir|plugin.tar.gz" >&2
+  echo "Usage: ${0##*/} [--download] [--section section name] [-b|--branch branch] [-e|--email mail] [--depends] plugin-dir|plugin.tar.gz" >&2
   exit 1
 }
 
@@ -14,6 +32,10 @@ load_dsc() {
     for dep in $TDEPENDS; do
       PL_DEPENDS="gosa-plugin-$dep, $PL_DEPENDS"
     done
+    TCONFLICTS=$(sed -n 's/"//g;s/^conflicts\s*=\s*\(.*\)$/\1/p' "$1")
+    for dep in $TCONFLICTS; do
+      PL_CONFLICTS="gosa-plugin-$dep, $PL_CONFLICTS"
+    done
     PL_DESCRIPTION=$(sed -n 's/"//g;s/^description\s*=\s*\(.*\)$/\1/p' "$1")
     PL_AUTHOR=$(sed -n 's/"//g;s/^author\s*=\s*\([^<]*\).*$/\1/p' "$1")
     PL_MAIL=$(sed -n 's/"//g;s/^author\s*=[^<].*<\([^>]*\).*$/\1/p' "$1")
@@ -24,7 +46,7 @@ load_dsc() {
 }
 
 
-TEMP=`getopt -o e:r: --long download,release:,email:,depends: -n 'dh-make-gosa' -- "$@"`
+TEMP=`getopt -o e:r: --long download,release:,email:,depends:,section: -n 'dh-make-gosa' -- "$@"`
 if [ $? != 0 ] ; then
   echo "Error: cannot get command line information" >&2
   exit 1
@@ -36,6 +58,7 @@ eval set -- "$TEMP"
 RELEASE=trunk
 DOWNLOAD=
 DEPENDS=
+SECTION=web
 DEST=
 while true; do
   case "$1" in
@@ -51,11 +74,15 @@ while true; do
     --depends)  DEPENDS="$2"
                 shift 2
                 ;;
+    --section)  SECTION="$2"
+                shift 2
+                ;;
     --dest)     DEST=$2/
                 shift 2
                 ;;
     --download) DOWNLOAD=yes
-                shift 1
+               echo "Download is not implemented yet"
+               exit 1
                 ;;
     --)         shift
                 break
@@ -75,7 +102,11 @@ if [ -d "$file" ]; then
   load_dsc $file/plugin.dsc
 
   # Setup build environment
-  BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}${ADD_VERSION}
+  if [ "$OVERRIDE_VERSION" ]; then
+         BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${OVERRIDE_VERSION}
+  else
+         BUILD_PATH=${DEST}gosa-plugin-${PL_NAME}-${PL_VERSION}
+  fi
   if [ -d "$BUILD_PATH" ]; then
     echo "Error: build path $BUILD_PATH already exists" >&2
     exit 2
@@ -93,7 +124,7 @@ elif [ -f "$file" ]; then
 
   # Untar
   mkdir -p "$TMPDIR"
-  tar --extract --directory "$TMPDIR" -fz "$file" &> /dev/null
+  tar --extract --directory "$TMPDIR" -fz "$file" >/dev/null 2>&1
   if [ $? -ne 0 ]; then
     echo "Error: cannot extract plugin file - invalid file format" >&2
     exit 5
@@ -120,19 +151,18 @@ echo "Plugin:       $PL_NAME"
 echo "Version:      $PL_VERSION"
 echo "Description:  $PL_DESCRIPTION"
 echo "Depends:      $PL_DEPENDS"
+echo "Conflicts:    $PL_CONFLICTS"
 echo "Author name:  $PL_AUTHOR"
 echo "Author email: $PL_MAIL"
 echo
 read -s -n 1 -p "Do you want to continue? (y/n)" ans; echo
 [ "$ans" != "y" ] && exit 0
 
-pushd . &> /dev/null
-
 cd "$BUILD_PATH"
 
 # Use gosa-plugin skelleton
 echo "Calling dh_make..."
-echo | dh_make -e "$PL_MAIL" -c gpl -s -n -f gosa-plugin-${PL_NAME}-${PL_VERSION}.tar.gz &> /dev/null
+echo | dh_make -e "$PL_MAIL" -c gpl -s -n -f gosa-plugin-${PL_NAME}-${PL_VERSION}.tar.gz >/dev/null 2>&1
 if [ $? -ne 0 ]; then
        echo "Failed to call dh_make - aborting!"
        exit 1
@@ -141,14 +171,14 @@ fi
 echo "Apdapting debian descriptive files..."
 
 # Generate install file
-for dir in admin personal addons; do
-       [ -d $dir ] && echo -e "$dir\t\t\t/usr/share/gosa/plugins" >> debian/install
+for dir in admin personal addons gofax gofon generic; do
+       [ -d $dir ] && printf "$dir\t\t\t/usr/share/gosa/plugins\n" >> debian/install
 done
 for dir in help/*; do
-       echo -e "$dir\t\t\t/usr/share/gosa/doc/plugins/$PL_NAME" >> debian/install
+       printf "$dir\t\t\t/usr/share/gosa/doc/plugins/$PL_NAME\n" >> debian/install
 done
 for dir in $(ls -1 locale | grep -v "^en$" | grep -v "^messages.po$"); do
-       echo -e "locale/$dir\t\t\t/usr/share/gosa/locale/plugins/$PL_NAME" >> debian/install
+       printf "locale/$dir\t\t\t/usr/share/gosa/locale/plugins/$PL_NAME\n" >> debian/install
 done
 
 # Generate dirs
@@ -174,9 +204,17 @@ sed -i "/.put author's name and email here.\
 sed -i '/^Upstream/,/^$/d' debian/copyright
 
 # Adapt control
-sed -i 's/^Section: unknown/Section: web/g' debian/control
+sed -i "s#^Section: unknown#Section: $SECTION#g" debian/control
 sed -i 's/^Architecture: any/Architecture: all/g' debian/control
-sed -i 's/^Depends: .*$/Depends: gosa/g' debian/control
+if [ "$PL_DEPENDS" ]; then
+       sed -i "s/^Depends: .*$/Depends: gosa, $PL_DEPENDS/g" debian/control
+else
+       sed -i 's/^Depends: .*$/Depends: gosa/g' debian/control
+fi
+if [ "$PL_CONFLICTS" ]; then
+       sed "11Conflicts: $PL_CONFLICTS" debian/control
+fi
+sed -i 's/^\(Build-Depends: .*\)$/\1, dpatch/g' debian/control
 sed -i "s/^Description: .*$/Description: $PL_NAME plugin for GOsa/g" debian/control
 sed -i "s/^ <.*$/ %DESCRIPTION%/g" debian/control
 dsc=$(tempfile)
@@ -192,6 +230,9 @@ sed -i "/%DESCRIPTION%/r $dsc" debian/control
 sed -i "/%DESCRIPTION%/d" debian/control
 rm $dsc
 
+# Create patch directory
+[ ! -d debian/patches ] && mkdir debian/patches
+
 # Adapt README.debian
 cat <<EOF > debian/README.Debian
 README.Debian for GOsa $PL_NAME plugin $PL_VERSION
@@ -224,20 +265,29 @@ configure-stamp:
        dh_testdir
        touch configure-stamp
 
+patch: patch-stamp
+patch-stamp:
+       dpatch apply-all
+       dpatch cat-all >patch-stamp
 
-build: build-stamp
+build: patch build-stamp
 
 build-stamp: configure-stamp 
        dh_testdir
 
        touch $@
 
-clean:
+clean: clean-patched unpatch
+clean-patched:
        dh_testdir
        dh_testroot
        rm -f build-stamp configure-stamp
        dh_clean 
 
+unpatch:
+       dpatch deapply-all
+       rm -rf patch-stamp debian/patched
+
 install: build
        dh_testdir
        dh_testroot
@@ -293,9 +343,7 @@ done\
 done
 
 # Remove examples
-rm debian/*ex debian/*EX &> /dev/null
-
-popd &> /dev/null
+rm debian/*ex debian/*EX >/dev/null 2>&1
 
 echo "Done."